VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} frmImportContactsFromTextFile 
   Caption         =   "Import Contacts from Text File"
   ClientHeight    =   4224
   ClientLeft      =   36
   ClientTop       =   324
   ClientWidth     =   10212
   OleObjectBlob   =   "frmImportContactsFromTextFile.frx":0000
   StartUpPosition =   1  'CenterOwner
End
Attribute VB_Name = "frmImportContactsFromTextFile"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'Declare variables as specific data types for VBA
Dim fld As Outlook.MAPIFolder

Private Sub cmdImportContacts_Click()
'Created by Helen Feddema 9-16-2000
'Last modified 9-16-2000

'VBA supports full error handling
On Error GoTo ErrorHandler

   Dim nms As Outlook.NameSpace
   Dim flds As Outlook.Folders
   Dim itms As Outlook.Items
   Dim itm As Outlook.ContactItem
   Dim strOfficePath As String
   Dim appAccess As Access.Application
   Dim strFolder As String
   Dim strDBName As String
   Dim strVersion As String
   Dim lst As MSForms.ListBox
   Dim fFound As Boolean
   
   'Use just Application for referencing the Outlook Application object in VBA
   Set nms = Application.GetNamespace("MAPI")

   'Reference listbox control using Me keyword
   Set lst = Me.lstImportProgress

   'Use the following code segment if contacts are to be stored in a custom folder
   strFolder = "Special Contacts"
   Set flds = nms.Folders("Personal Folders").Folders

   'Check for existence of Special Contacts folder and create it if not found
   fFound = FindFolder(flds, 1, strFolder)

   If fFound = True Then
      lst.AddItem "Seting fld variable to existing folder"
      Set fld = flds(strFolder)
   ElseIf fFound = False Then
      lst.AddItem "Setting fld variable to newly created folder"
      'Use named constant for Type variable for VBA
      Set fld = flds.add(strFolder, olFolderContacts)
   End If

   'Pick up path to Access database directory from Access and Office
   'version from Outlook
   Set appAccess = Application.CreateObject("Access.Application")
   strOfficePath = appAccess.SysCmd(9)
   lst.AddItem "Access folder: " & strOfficePath
   
   'Get Office version from Outlook
   strVersion = Application.Version

   If Left(strVersion, 1) = "8" Then
      strDBName = strOfficePath & "Special Contacts 97.mdb"
   ElseIf Left(strVersion, 1) = "9" Then
      strDBName = strOfficePath & "Special Contacts 2000.mdb"
   Else
      MsgBox "Unknown Office version; canceling"
      Exit Sub
   End If

   lst.AddItem "Database name: " & strDBName

   lst.AddItem "Running Access function to import records from text file into an Access table"
   appAccess.OpenCurrentDatabase strDBName
   appAccess.Run "ImportTextFile"

   lst.AddItem "Runing Access function to export massaged records to Outlook contact items, using a custom contact form"
   appAccess.Run "ExportToOutlook"
   appAccess.Quit
   lst.AddItem "All contacts imported into Special Contacts folder!"

ErrorHandlerExit:
   Exit Sub

ErrorHandler:
   MsgBox "Error No: " & Err.Number & "; Description: " & Err.Description
   Resume ErrorHandlerExit

End Sub
    
'Function can be data typed in VBA
Function FindFolder(fldsParent As Outlook.Folders, intDepth As Integer, _
   strFolder As String) As Boolean
'Created by Helen Feddema 9-16-2000
'Last modified 9-16-2000

On Error GoTo ErrorHandler

      For Each fld In fldsParent
      If fld.Name = strFolder Then
         FindFolder = True
         Exit Function
      End If
   Next

ErrorHandlerExit:
   Exit Function

ErrorHandler:
   MsgBox "Error No: " & Err.Number & "; Description: " & Err.Description
   Resume ErrorHandlerExit

End Function
   
Private Sub UserForm_Click()

End Sub
